﻿if(typeof($)=='undefined')
	$={};

$._ext = {
    //Evaluate a file and catch the exception.
    evalFile : function(path) {
        try {
            $.evalFile(path);
        } catch (e) {alert("Exception:" + e);}
    },
    // Evaluate all the files in the given folder 
    evalFiles: function(jsxFolderPath) {
        var folder = new Folder(jsxFolderPath);
        if (folder.exists) {
            var jsxFiles = folder.getFiles("*.jsx");
            for (var i = 0; i < jsxFiles.length; i++) {
                var jsxFile = jsxFiles[i];
                $._ext.evalFile(jsxFile);
            }
        }
    },

    convertTypeID: function  (typeArray) {
      return typeIDToStringID(Number(typeArray));
    },
    
    fileModificationDate: function(fileName){
      var fileRef = File(fileName);
      
      return fileRef.modified;
    },

    deleteFile: function(fileName) {
     var fileRef = File(fileName);
     fileRef.remove ();
    },
 
    documentsOpen: function(){
	    try {
	    	var xLib = new ExternalObject("lib:\PlugPlugExternalObject");
	    	if (xLib) {
			    var eventObj = new CSXSEvent(); 
			    eventObj.type = "com.Miles33.i4.script.documentsOpen";
			    eventObj.data = (app.documents.length > 0).toString();
			    eventObj.dispatch();
			}
		} catch (e) {
		    alert(e);
		}
	},
	
	 documentsClose: function(){
	    try {
			var fileName = null;
			while ( app.documents.length > 0 && app.activeDocument != null && fileName != app.activeDocument.fullName ){
				fileName = app.activeDocument.fullName;
				app.activeDocument.close();
			}

		} catch (e) {
		}
	}
};
