function GNDocumentBase()
{
	
}

GNDocumentBase.prototype.doneFilefromWeb = function(fileName, format){
 
};

GNDocumentBase.prototype.errorFilefromWeb = function() {
 
};

GNDocumentBase.prototype.setID = function(id) {
	this.id = id;
};

GNDocumentBase.prototype.getID = function() {
	return this.id;
};

GNDocumentBase.prototype.setName = function($item) {
	var self = this;
	self._gn4Name = $item.find('title').text();
	if ( self._gn4Name === undefined || self._gn4Name.length == 0 ){
		self._gn4Name = $item.attr('name');
	}
};

GNDocumentBase.prototype.setMimetype = function($item) {
	var self = this;
	var dataName = 'data';
	if ( $item.length === 1 && $item[0].nodeName === 'img' )
	{
		dataName = 'low';
	}
	self._mimetype = $item.find(dataName).attr('mime');
	return dataName;
};

GNDocumentBase.prototype.setFileName = function(fileName) {
	this.fileName = fileName;
};


GNDocumentBase.prototype.getFileName = function() {
	return this.fileName;
};

GNDocumentBase.prototype._getValidFileName = function (name) {
	return name.replace(/[^a-z0-9,._]/ig, '_');
};

GNDocumentBase.prototype._getFolderPath = function () {
	var ret = csInterface.getSystemPath(SystemPath.MY_DOCUMENTS);
	return ret;
};

GNDocumentBase.prototype._getFilefromWeb = function (dataName, format) {
	var self = this;
	var url = getBaseURL() + "api/data/";
	url += self.getID();
	url += "?encoding=base64&name=";
	url += dataName;
	 $.ajax({
	   type: "GET",
        url: url
      })
      .done(function (data, textStatus, jqXHR) {
    	  try {
    		  var ext = cacheData.getExtension(self._mimetype);
    		  self.setFileName(self._getFolderPath() + "/" + self._getValidFileName(self._gn4Name) + "_" + self.getID() + "." + ext);
    		  result = window.cep.fs.writeFile(self.getFileName(), data, cep.encoding.Base64);
    			if (0 == result.err){
					self.doneFilefromWeb(self.getFileName(), format);
    	        }
    			else {
    				alert(resourceBundle.WritingFileErr.replace("{0}", self.getFileName()));
    			} 
    	  }
  		catch(err) {
  		    alert(err.message);
			self.errorFilefromWeb();
  		}
      });
};

function GNDocument()
{
	GNDocumentBase.call(this);
	this.lastUploadTime = null;
	this.isOpened = false;
	this.converting = false;
};

GNDocument.prototype = Object.create(GNDocumentBase.prototype);

GNDocument.prototype.constructor = GNDocument;

GNDocument.prototype.isOpen = function()
{
	var self=this;
	return self.isOpened;
};

GNDocument.prototype.open = function(id, format)
{
   var self = this;
   var ret = true;
   self.setID(id);
   if (self._checkedId != undefined && self.fileName != null ) {
	   self._openFile(self.fileName, format);
   }else {
	   $.ajax({
		   type: "GET",
	        url: getBaseURL() + "do.ashx?cmd=get&attrs=data,low&attrstocheckout=low,name,data&datacomplete=true&strict=true&ids=" + self.getID()
	      })
	      .done(function (data) {
	    	  var $obj = $(data).find('GenericAccessObj obj');
	    	  var $check = $(data).find('GenericAccessObj check');
	    	  
	    	  if ( $check.length > 0 ){
		    	self._type = "image";
		    	var $image = $obj.find(self._type);
		    	if ( $image.length == 0 )
	    		{
		    		self._type = "img";
		    		$image = $obj.find(self._type);
	    		}
		    	
				self.setName($image);
		        
		        self._dataName = self.setMimetype($image);
		        
		        self._checkedTicket = $check.attr('LoginGuid');
		        self._checkedId = $check.attr('Id');
		        		        
		    	self._getFilefromWeb(self._dataName, format);

	    	  } else {
	    		  alert(resourceBundle.CheckOutErrorKey);
	    	  }
	      })
	      .fail(function (xhr) {
	    	  alert(parseException(xhr));
	      });
   }
   return ret;
};

GNDocument.prototype.save = function(doClose)
{
	var self = this;
	if ( self.fileName != null ){
		try {
            var extScript = "$._ext.fileModificationDate('" + self.fileName + "')";
            evalScript(extScript, function (ret) {
            	if ( self.lastUploadTime < ret ) {
					if (!self.uploadingTime) {
						self.needToSave = false;
						self.uploadingTime = ret;
						var result = window.cep.fs.readFile(self.fileName, window.cep.encoding.Base64);

						$.ajax({
							type: "POST",
							url: getBaseURL() + "do.ashx?cmd=wf&name=Update" + self._type + "FromPS&ids=" + self.getID() + "&pars=encoding:base64;ObjectIds:" + self.getID(),
							data: result.data,
							contentType: "text/plain"
						})
							.done(function (data) {
								self.uploadingTime = undefined;
								self.lastUploadTime = ret;
								if (self.needToSave) {
									self.save(doClose);
								} else if (doClose) {
									self._close();
								}
								var refreshEvent = new CSEvent("com.Miles33.I4.refresh", "APPLICATION", csInterface.getApplicationID(), csInterface.getApplicationID());

								csInterface.dispatchEvent(refreshEvent);

							})
							.fail(function (xhr) {
								self.uploadingTime = undefined;
								if (self.needToSave) {
									self.save(doClose);
								}
								alert(parseException(xhr));

							});
					} else if (self.uploadingTime < ret) {
						self.needToSave = true;
					}
				}
            });
		}
		catch(err) {
		    alert( err.message);
		}
	}
};

GNDocument.prototype.close = function()
{
	var self = this;
	if ( self.fileName != null && !self.converting ){
		var extScript = "$._ext.fileModificationDate('" + self.fileName +"')";
		evalScript(extScript, function(ret) {
			if (self.lastUploadTime == null || self.lastUploadTime < ret) {
				self.save(true);
			} else {
				self._close();
			}
		});
	}
};

GNDocument.prototype._close = function()
{
	var self = this;
	if ( self.fileName != null ){
		var extScript = "$._ext.deleteFile('" + self.fileName +"')";
		evalScript(extScript, function() {
			self.isOpened = false;
			self.fileName = null;
			self._checkIn();
			commandHandler.removeDocument(self);
		});
	}
};

GNDocument.prototype._checkIn = function()
{
	var self = this;
	if ( self._checkedId) {
		$.ajax({
		   type: "GET",
	        url: getBaseURL() + "do.ashx?cmd=uncheck&ticket=" + self._checkedTicket + "&check=id:" + self._checkedId
	      })
	      .done(function (data) {
	    	  self._checkedTicket = null;
	    	  self._checkedId = null;
	      });
	}
};


GNDocument.prototype._openFile = function(filename, format) {
	var self = this;
    var extScript = "$._ext_" + csInterface.hostEnvironment.appName + ".open('";
    extScript += filename;
    extScript += "')";
    evalScript(extScript);
    self.isOpened = true;
    this.convert(format);
};

GNDocument.prototype.doneFilefromWeb = function(fileName, format){
	var self = this;
	self._openFile(fileName, format);
	var extScript = "$._ext.fileModificationDate('" + fileName +"')";
	evalScript(extScript, function(ret) {
		self.lastUploadTime = ret;
	});
};

GNDocument.prototype.errorFilefromWeb = function(fileName){
  this._checkIn();
};

GNDocument.prototype.convert = function(format){
	var self = this;
	if ( csInterface.hostEnvironment.appName == "PHXS" || csInterface.hostEnvironment.appName == "PHSP") {
		if (format == "native") {
			switch (csInterface.hostEnvironment.appName) {
				case "PHXS":
				case "PHSP": {
					format = "vdn.adobe.photoshop";
					break;
				}
				default: {
					format = undefined;
					break;
				}
			}
		}
		if (format) {
			var newFileName = self.getFileName();
			var ext = cacheData.getExtension(format);
			var endIndex = newFileName.lastIndexOf(".");
			newFileName = newFileName.substr(0, endIndex + 1) + ext;

			if (newFileName.toLowerCase() != self.getFileName().toLowerCase()) {
				self.converting = true;
				console.log("doing save as");
				var extScript = "$._ext_" + csInterface.hostEnvironment.appName + ".saveAs('" + self.getFileName() + "', '" + newFileName + "')";
				csInterface.evalScript(extScript, function (ret) {
                    console.log("done save as");
					if (ret == "true") {
						var extScript = "$._ext.deleteFile('" + self.getFileName() +"')";
						self.setFileName(newFileName);
						evalScript(extScript, function() {});
						self.save();
					}
					self.converting = false;
				});
			}
		}
	}
};

GNDocument.prototype.isConverting = function()
{
	var self=this;
	return self.converting;
};