var csInterface = new CSInterface();
var ENTER_KEY = 13;
var TAB_KEY = 9;
var resourceBundle;

function loadJSX() {
    var extensionRoot = csInterface.getSystemPath(SystemPath.EXTENSION) + "/jsx/";
    csInterface.evalScript('$._ext.evalFiles("' + extensionRoot + '")');
}

function evalScript(script, callback) {
	csInterface.evalScript(script, callback);
}

function doneLoad(){
	resourceBundle = csInterface.initResourceBundle();
    var appName = csInterface.hostEnvironment.appName;
    
    if(appName != "FLPR"){
    	loadJSX();
    }
}

function parseException(xhr) {
    if (xhr.responseText) {
      try {
        var error = JSON.parse(xhr.responseText);
        if (error.ExceptionMessage && error.ExceptionMessage != null && error.ExceptionMessage.length > 0)
          return error.ExceptionMessage;

        return error.Message;
      }
      catch (x) {
      }
    }

    return xhr.statusText + ' (' + xhr.status + ')';
  }

function hostName(){
	var ret = csInterface.hostEnvironment.appName;
	switch(csInterface.hostEnvironment.appName)
	{
		case 'IDSN':
		{
			ret = "com.adobe.indesign";
			break;
		}
		case 'AICY':
		{
			ret = "com.adobe.incopy";
			break;
		}
		case "PHXS":
		case "PHSP":
		{
			ret = "com.adobe.photoshop";
			break;
		}
		case "PPRO":
		{
			ret = "com.adobe.premiere";
			break;
		}
	}
	return ret;
}

var lut = []; for (var i=0; i<256; i++) { lut[i] = (i<16?'0':'')+(i).toString(16); }
function guid()
{
var d0 = Math.random()*0xffffffff|0;
var d1 = Math.random()*0xffffffff|0;
var d2 = Math.random()*0xffffffff|0;
var d3 = Math.random()*0xffffffff|0;
return lut[d0&0xff]+lut[d0>>8&0xff]+lut[d0>>16&0xff]+lut[d0>>24&0xff]+'-'+
  lut[d1&0xff]+lut[d1>>8&0xff]+'-'+lut[d1>>16&0x0f|0x40]+lut[d1>>24&0xff]+'-'+
  lut[d2&0x3f|0x80]+lut[d2>>8&0xff]+'-'+lut[d2>>16&0xff]+lut[d2>>24&0xff]+
  lut[d3&0xff]+lut[d3>>8&0xff]+lut[d3>>16&0xff]+lut[d3>>24&0xff];
}