function Config(name, details) {
	this._name = name;
	this._ticketInfo = details;
};

Config.prototype.get = function () {
	var ret = "";
	$.when( $.ajax(this.url) ).done(function( item ) {
		ret = item;
	});
	return ret;	
};

Config.prototype.url = function () {
	var self = this;
	var ret = self._ticketInfo.getURL();
	ret += "do.ashx?cmd=config&name=";
	ret += self._name;
	ret += "&who=";
	ret += self._ticketInfo.getUserID();
	ret += "&ticket=";
	ret += self._ticketInfo.getTicket();
	ret += "&random=";
	ret += guid();
	return ret;
};

Config.prototype.post = function (data) {
	$.ajax({
        type: "POST",
        url: this.url,
        data: data,
        contentType: "application/xml"
      });
};
