function PPROCommandHandler()
{
	BaseCommandHandler.call(this);
	var self = this;
	self._renders = [];
	var extScript = "$._ext_" + csInterface.hostEnvironment.appName + ".keepPanelLoaded()";
	evalScript(extScript);
	
	csInterface.addEventListener("com.Miles33.GN4.getArticles", function(){
		evalScript("$._ext_" + csInterface.hostEnvironment.appName + ".getIds('" + cacheData.getSystemGuid() + "')", function(ret) {
			var importEvent = new CSEvent("com.Miles33.GN4UI.articles", "APPLICATION", csInterface.getApplicationID(), csInterface.getApplicationID());
			importEvent.data = '<gn4 imgIds="' + ret + '" articleIds=""></gn4>';
			csInterface.dispatchEvent(importEvent);			
		});
		
	});
	
	var extScript = "$._ext_" + csInterface.hostEnvironment.appName + ".getProjectFilePath()";
	evalScript(extScript, function(projectPath) {
		var endloc = projectPath.lastIndexOf('.');
		if ( endloc < 0 ){
			endloc = projectPath.length;
		}
		var stLoc = projectPath.indexOf('\\\\?\\');
		if ( stLoc == 0 ){
			stLoc = 4;
		} else {
			stLoc = 0;
		}
		self.projectPath = projectPath.substr(stLoc, endloc - stLoc).replace(/\\/g, "/");
		window.cep.fs.makedir(self.projectPath);
	});
	
	csInterface.addEventListener("com.Miles33.GN4.UpdateProjectItems", function(){
		var extScript = "$._ext_" + csInterface.hostEnvironment.appName + ".getIds('" + cacheData.getSystemGuid() + "')";
		evalScript(extScript, function(ids) {
			if ( ids && ids.length > 0 ){
				$.ajax({
					type: 'GET',
					url: getBaseURL() + 'do.ashx?cmd=get&attrs=data,low&datacomplete=true&strict=true&extras=ModifiedDetails&ids=' + ids
				})
				.done(function (data) {
					$(data).find('GenericAccessObj').each(function(){
						var $modifed = $(this).find('extra[n="ModifiedDetails"] Content');
						var $image = $(this).find('obj').children();
											
						var doc = new PPROUpdateDocument(self.getProjectPath());
						doc.update($image, $modifed.attr('Time'));	
					});
				})
				.fail(function (xhr) {
				  alert(parseException(xhr));
				});
			}
		});

	});
		
	csInterface.addEventListener("com.Miles33.GN4.render", function(event){
		var render = new PPRORenderHandler();
		self._renders.push(render);
		render.render();
	});
};

PPROCommandHandler.prototype = Object.create(BaseCommandHandler.prototype);

PPROCommandHandler.prototype.constructor = PPROCommandHandler;

PPROCommandHandler.prototype.placeFromI4 = function(event) {
	var self = this;
	evalScript("$._ext_" + csInterface.hostEnvironment.appName + ".getIds('" + cacheData.getSystemGuid() + "')", function(ret) {
		var items = [];
		if ( ret && ret.length > 0 ){
			items = ret.split(',');
		}
		if ( items.length == 0 || items.indexOf(event.data.id.toString()) < 0 ){
			var doc = new PPRODocument(self.getProjectPath());
			doc.place(event.data.id);
		} else {
			alert(resourceBundle.AllreadyImportedErr);
		}
	});
};

PPROCommandHandler.prototype.getProjectPath = function(){
	var ret = this.projectPath + "/" + cacheData.getSystemGuid();
	window.cep.fs.makedir(ret);
	return ret;
};
