
function PPRODocument(projectPath)
{
	GNDocumentBase.call(this);
	this.projectPath = projectPath;
};

PPRODocument.prototype = Object.create(GNDocumentBase.prototype);

PPRODocument.prototype.constructor = PPRODocument;

PPRODocument.prototype._getFolderPath = function () {
	return this.projectPath;
};

PPRODocument.prototype.place = function(id)
{
	var self = this;
	self.setID(id);
	
	$.ajax({
		type: 'GET',
		url: getBaseURL() + 'do.ashx?cmd=get&attrs=data,low&datacomplete=true&strict=true&extras=ModifiedDetails&ids=' + self.getID()
	})
	.done(function (data) {
		var $gobj = $(data).find('GenericAccessObj');
		var $modifed = $gobj.find('extra[n="ModifiedDetails"] Content');
		self._modDate = $modifed.attr('Time');
		var $image = $gobj.find('obj').children();
			
		self.setName($image);
				
		var dataName = self.setMimetype($image);

		self._getFilefromWeb(dataName);
	})
	.fail(function (xhr) {
	  alert(parseException(xhr));
	});	
};


PPRODocument.prototype.doneFilefromWeb = function(fileName, format){
	var self = this;
	var extScript = "$._ext_" + csInterface.hostEnvironment.appName + ".importFile('" + fileName +"', " + self.getID() + ", '" + self._modDate + "', '" + cacheData.getSystemGuid() + "')";
	evalScript(extScript);
};
