function PPRORenderHandler()
{
	var self = this;
	//self._jobId = undefined;
};

PPRORenderHandler.prototype.render = function(){
	var self = this;
	var _jobId = undefined;
	var _renderSuccessEvent = function(event){
		console.log("_renderSuccessEvent:" + event.data);
		var items = event.data.split('|');
		if ( items.length == 2 ){
			console.log("_renderSuccessEvent: split");
			console.log("_renderSuccessEvent: jobId '" + _jobId + "'");
			console.log("_renderSuccessEvent: items '" + items[0] + "'");
			if ( _jobId == items[0] ){
				console.log("_renderSuccessEvent: jobId match: " + _jobId);
				csInterface.removeEventListener("com.Miles33.i4.render.done", _renderSuccessEvent);
				csInterface.removeEventListener("com.Miles33.i4.render.error", _renderErrorEvent);
				console.log("about to read file");
				self._sendFile(items[1]);				
			}else {
				console.log("JobId does not match");
			}
		} else {
			console.log("Invalid items from render");
		}
	};
	
	var _renderErrorEvent = function(event) {
		var items = event.data.split('|');
		if ( items.length == 2 ){
			if ( _jobId == items[0] ){
				csInterface.removeEventListener("com.Miles33.i4.render.done", _renderSuccessEvent);
				csInterface.removeEventListener("com.Miles33.i4.render.error", _renderErrorEvent);
				self._renderError(items[1]);
			}else {
				console.log("JobId does not match in error");
			}
		}else {
			console.log("Invalid items from render in error");
		}
	};
	
	csInterface.addEventListener("com.Miles33.i4.render.done", _renderSuccessEvent);
	csInterface.addEventListener("com.Miles33.i4.render.error", _renderErrorEvent);
		
	var presetPath = csInterface.getSystemPath(SystemPath.EXTENSION) + '/payloads/MatchSource.epr';
	csInterface.evalScript("$._ext_" + csInterface.hostEnvironment.appName + ".render('" + presetPath + "', '" +  self._getOutputPath() + "')", function(ret){
		console.log("started render: ");
		if ( ret){
			console.log("started render: " + ret);
			var items = ret.split('|');
			if (items.length == 2 ){
				switch ( items[0] ){
					case "JobID":{
						_jobId = items[1];
						console.log("started render: _jobId " + _jobId);
						break;
					}
					case "Error":{
						self._renderError(items[1]);
						break;
					}
				}	
			} else {
				self._renderError(resourceBundle.RenderInvalid);
			}
		} else {
			self._renderError(resourceBundle.RenderNull);
		}
	});
};

PPRORenderHandler.prototype._getOutputPath = function() {
	var ret = csInterface.getSystemPath(SystemPath.MY_DOCUMENTS) + "/Miles_33_GN4_PPRO"
	window.cep.fs.makedir(ret);
	return ret;
};

PPRORenderHandler.prototype._renderError = function(errorMessage) {
	this._renderSend("com.Miles33.GN4.render.error", errorMessage);
};

PPRORenderHandler.prototype._renderSend = function(eventId, message) {
	var errorEvent = new CSEvent(eventId, "APPLICATION", csInterface.getApplicationID(), csInterface.getApplicationID());
	errorEvent.data = message;
	console.log("Sending message : " + eventId + ", size: " + message.length);
	csInterface.dispatchEvent(errorEvent);

};

PPRORenderHandler.prototype._sendFile = function(filename) {
	var self = this;
	var request = require('request');
	var fs = require('fs');
	
	if ( request ){		
		var stats = fs.statSync(filename)
		
		var myFile = fs.createReadStream(filename);
		
		var headers = {
			'Content-Length':  stats.size    
		}
		
		request.post({
			url: getBaseURL() + 'do.ashx?cmd=tempfile&ticket=' + cacheData.getTicket(),
			headers: headers,
			body: myFile
		}, function(error, response, body){
			if (response.statusCode == 200 ){
				self._renderSend("com.Miles33.GN4.render.success", body);
			} else {
				self._renderError(parseException(response));
			}
		});
	} else {
		self._renderError(resourceBundle.RenderErrorSending);
	}
};
