function RequestTicket(gotTicket) {
	this._gotTicket = gotTicket;
	this.request();
};

RequestTicket.prototype.request = function () {
	var self = this;
	self._ticketFromGN4 = function (event)
	{
		csInterface.removeEventListener("com.Miles33.GN4UI.ticket", self._ticketFromGN4);
		var xmlDoc = $.parseXML(event.data);
		var xdata = $(xmlDoc).find('gn4');
				
		if ( xdata.length > 0 ){		
			self._url = xdata.attr('server');
			self._ticket = xdata.attr('ticket');
			self._userID = xdata.attr('userID');
			self._webForm = xdata.attr('webform');
		}
		
		// blank the url if not logged in.
		if ((self._url != undefined && self._url != null && self._url.length > 0) && (self._ticket == undefined || self._ticket == null || self._ticket.length == 0 )){
			self._url = "";
		} 
		
		if (self._gotTicket ) {
			self._gotTicket();
		}
	};
	csInterface.addEventListener("com.Miles33.GN4UI.ticket", self._ticketFromGN4);
	var ticketEvent = new CSEvent("com.Miles33.GN4.requestTicket", "APPLICATION", csInterface.getApplicationID());
	csInterface.dispatchEvent(ticketEvent);	
};

RequestTicket.prototype.clean = function () {
	var self = this;
	csInterface.removeEventListener("com.Miles33.GN4UI.ticket", self._ticketFromGN4);
};

RequestTicket.prototype.getURL = function () {
	return this._url;
};

RequestTicket.prototype.getTicket = function () {
	return this._ticket;
};

RequestTicket.prototype.getUserID = function () {
	return this._userID;
};

RequestTicket.prototype.getWebForm = function () {
	return this._webForm;
};
