﻿$._ext_ILST={
   open: function(fileName){
      var fileRef = File(fileName);
      var docRef = app.open(fileRef);
      var ret = docRef.fullName;
      return ret;
    },

    close: function(){
       var doc = app.activeDocument;
            if ( doc != null )
            {
                doc.close();
            }
    },

    save: function(){
        var ret = "";
        try
        {
            var doc = app.activeDocument;
            if ( doc != null  && doc.fullName && !doc.saved)
            {
                doc.save();
            }
        }
        catch(err)
        {
            ret = err;
        }
        return ret;
    },

    isOpen: function(fileName){
        var ret = false;
        var fileRef = File(fileName);
        for (var i=0; i<app.documents.length;i++)
        {
        	var fileRef2 = File(app.documents[i].fullName);
            if ( fileRef.fullName == fileRef2.fullName) {
                ret = true;
                break;
            }
        }
        return ret;
     },
 
    current: function(){
        var ret = this.save();
        if ( ret.length == 0 )
        {
            var doc = app.activeDocument;
            if ( doc != null )
           {
               ret = "path:" +doc.fullName.fsName;
            }
        }
        return ret;
     },

    saveAs: function(oldFileName, newFileName){
        var ret = false;
        var fileRef = File(oldFileName);
        for (var i=0; i<app.documents.length;i++)
        {
            var fileRef2 = File(app.documents[i].fullName);
            if ( fileRef.fullName == fileRef2.fullName) {
                var newFileRef = File(newFileName);
                app.documents[i].saveAs(newFileRef);
                ret = true;
                break;
            }
        }
        return ret;
    },
};
