﻿$._ext_IDSN={
   open: function(fileName){
      var fileRef = File(fileName);
      app.open(fileRef);
    },

 	close: function(){
       var doc = app.activeDocument;
            if ( doc != null )
            {
                doc.close();
            }
    },

    save: function(){
        var ret = "";
        try
        {
            var doc = app.activeDocument;
            if ( doc != null  && doc.fullName && doc.saved)
            {
                doc.save();
            }
        }
        catch(err)
        {
            ret = err;
        }
        return ret;
    },
 
    current: function(){
        var ret = this.save();
        if ( ret.length == 0 )
        {
            var doc = app.activeDocument;
            if ( doc != null )
            {
               ret = "path:" +doc.fullName.fsName;
            }
        }
        return ret;
     },
     
     select: function(strIds) {
     	var ids = strIds.toString().split(',');
     	var selItems = [];
        var boxes = app.activeDocument.allPageItems;
     	for(var i = 0; i < boxes.length; i++ ) {
            for(var j = 0; j < ids.length; j++ ){
                if ( ids[j] == boxes[i].id){
                    selItems.push(boxes[i]);
                    break;
                }
            }
            if ( selItems.length == ids.length )
            {
                break;
            }
        }
        app.select(selItems);
     }, 
     
     getSelection: function(){
	    try {
	    	var xLib = new ExternalObject("lib:\PlugPlugExternalObject");
	    	if (xLib) {
	    		var ids = [];
	    		for (var i=0; i<app.selection.length; i++)
	    		{
	    			ids.push(app.selection[i].id);
	    		}
			    var eventObj = new CSXSEvent(); 
			    eventObj.type = "com.Miles33.i4.script.selection";
			    eventObj.data = ids.join(',');
			    eventObj.dispatch();
			}
		} catch (e) {
		    alert(e);
		}
	},
};