function onLoaded() {
	doneLoad();
        
    csInterface.addEventListener("com.Miles33.GN4UI.refreshOffline", refreshOffline);
    
    refreshOffline();
    
    
    var  flyoutMenu = 	'<Menu>' +
		'<MenuItem Id="I4Refresh" Label="' + resourceBundle.RefreshKey + '" Enabled="true" Checked="false"/>' +
	'</Menu>';

    csInterface.setPanelFlyoutMenu(flyoutMenu);

    csInterface.addEventListener("com.adobe.csxs.events.flyoutMenuClicked", flyoutMenuClicked);
}

function flyoutMenuClicked(event)
{
	if ( event.data.menuId = "I4Refresh"){
		refreshOffline();
	}
}

function getPath()
{
	return csInterface.getSystemPath(SystemPath.MY_DOCUMENTS) + "/Miles_33_GN4";
}

function refreshOffline(event)
{
	$('#fileList').empty();
	var path = getPath();
	var stat = window.cep.fs.stat(path);
	
	if ( stat.err == cep.fs.ERR_NOT_FOUND) {
		cep.fs.makedir(path);
	} else if ( stat.err == cep.fs.ERR_NOT_DIRECTORY ) {
		window.cep.fs.deleteFile(path);
		refreshOffline();
		return;
	}
	
	var files = window.cep.fs.readdir(path);
		
	files.data.forEach(function (file) {
		if ( file.indexOf(".indd") == file.length - 5 )
		{
			$('#fileList').append("<li>" + file + "</li>");
		}
	});
	
	$('#fileList li').on( "click", function() {
        var extScript = "$._ext_" + csInterface.hostEnvironment.appName + ".open('";
        extScript += getPath() + "/" + $( this ).text();
        extScript += "')";
        evalScript(extScript);
    });
}
